/*
 * blancoIg
 * Copyright (C) 2004-2005 Yasuo Nakanishi
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.struts.expander.form;

import java.util.Iterator;

import blanco.ig.expander.NameAdjuster;
import blanco.ig.expander.Type;
import blanco.ig.expander.Value;
import blanco.struts.definition.form.FieldValidation;
import blanco.struts.definition.form.FormField;
import blanco.struts.definition.form.FormTable;
import blanco.struts.expander.TypeFactory;
import blanco.struts.expander.form.base.BaseEventValidationMethod;
import blanco.struts.runtime.validator.Validator;
import blanco.struts.runtime.validator.message.ErrorMessageKey;

/**
 * @author Yasuo Nakanishi
 */
public class ValidateRequiredEventMethod extends BaseEventValidationMethod {

    public ValidateRequiredEventMethod(String event, Iterator eventFields,
            Iterator tableIterator, TypeFactory typeFactory) {
        super(createName(event), event, eventFields, tableIterator, typeFactory);
    }

    public static String createName(String event) {
        NameAdjuster na = getNameAdjuster();
        return createName("validate", "RequiredOn" + na.toTitleCase(event));
    }

    public void setupSignature() {
        super.setupSignature();

        String doc = "";

        doc = getName() + "イベント必須入力検証メソッド。";
        getJavaDoc().addLine(doc);

        doc = "このメソッドはActionクラスから呼び出してください。";
        getJavaDoc().addLine(doc);
    }

    protected void implemntFieldValidation(FormField field, Value errors) {
        Value fieldValue = getField(field.getValue().getName());

        if (field.getValidation().isCheckRequire()) {
	        addUsingType(getRuntimeType(Validator.class));
	        addUsingType(getRuntimeType(ErrorMessageKey.class));
	        addUsingType(new Type("org.apache.struts.action.ActionError"));
			
            Type type = getRuntimeType(ErrorMessageKey.class);
            getImplementor().checkRequire(errors, fieldValue, field, type);
            getImplementor().emptyLine();
        }
    }

    protected void implementTableValidation(Value item, FormField f, Value errors) {
        FieldValidation validation = f.getValidation();

        boolean requireCheck = validation.isCheckRequire();
        if (requireCheck) {
	        addUsingType(getRuntimeType(Validator.class));
	        addUsingType(getRuntimeType(ErrorMessageKey.class));
	        addUsingType(new Type("org.apache.struts.action.ActionError"));
			
            Type type = getRuntimeType(ErrorMessageKey.class);
            getImplementor().checkTableRequire(item, f, errors, type);
        }
    }

    protected boolean existTableValidation(String event, FormTable table) {
        return table.existEventRequireValidationField(event);
    }
}
